﻿Type=Class
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private mTarget As Object
	Private mEventName As String
	Private Btn1,Btn2 As Button
	Private Numero As Label
	Private mBase As Panel
	Private mLeft, mTop, mWidth, mHeight As Int
	Private mValue, mMax, mMin As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(TargetModule As Object, EventName As String)
	mTarget = TargetModule
	mEventName = EventName
End Sub

Public Sub DesignerCreateView(Base As Panel, lbl As Label, Props As Map)
	mLeft = Base.Left
	mTop = Base.Top
	mWidth = Base.Width
	mHeight = Base.Height
	mBase.Initialize("")
	mBase = Base
	Btn1.Initialize("btn1")
	Btn2.Initialize("btn2")
	Numero.Initialize("")
	mBase.AddView(Btn1, 0,0, mBase.Height,mBase.Height)
	mBase.AddView(Btn2, mBase.Width-mBase.Height,0, mBase.Height,mBase.Height)
	mBase.AddView(Numero,mBase.Height,0,mBase.Width - (2*mBase.Height),mBase.Height)
	
	Base.Color = Colors.Transparent
	Private mBCD As ColorDrawable
	mBCD.Initialize(Colors.Transparent, Floor(mBase.Height/10))
	mBase.Background = mBCD
	
	Private BtnCD As ColorDrawable
	BtnCD.Initialize2(Colors.Gray, Floor(Btn1.Height/10),DipToCurrent(1),Colors.DarkGray)
	Btn1.Background = BtnCD
	Btn2.Background = BtnCD
	
	Private NumCD As ColorDrawable
	NumCD.Initialize2(Colors.LightGray, Floor(Btn1.Height/10),DipToCurrent(1),Colors.darkGray)
	Numero.Background= NumCD
	
	Btn1.Text= "-"
	Btn2.Text= "+"
	Btn1.Gravity=Gravity.CENTER
	Btn2.Gravity=Gravity.CENTER
	Numero.Gravity = Gravity.CENTER
	
	Btn1.TextSize=SetTextSize(Btn1)
	Btn2.TextSize=SetTextSize(Btn1)
	Numero.TextSize = SetTextSize(Numero)
	
	Btn1.TextColor = Colors.Black
	Btn2.TextColor = Colors.Black
	Numero.TextColor = Colors.Black
	
	Btn1.Typeface = Typeface.DEFAULT_BOLD
	Btn2.Typeface = Typeface.DEFAULT_BOLD
	Numero.Typeface = Typeface.MONOSPACE
End Sub

Public Sub setLeft(value As Int)
	mBase.Left = value
End Sub
Public Sub getLeft  As Int
	Return mBase.Left
End Sub

Public Sub setWidth(value As Int)
	If value > 3*mBase.Height Then
		mBase.Width=value
		Btn2.Left= value-mBase.Height
		Numero.Width = value-(mBase.Height*2)
	Else
		mBase.Width=3*mBase.Height
		Btn2.Left= mBase.Width-mBase.Height
		Numero.Width = mBase.Width-(mBase.Height*2)
	End If
		Btn1.Width = mBase.Height
		Btn2.Width = mBase.Height
		Numero.Left = Btn1.Height
		Btn1.TextSize=SetTextSize(Btn1)
		Btn2.TextSize=SetTextSize(Btn1)
		Numero.TextSize = SetTextSize(Numero)
End Sub
Public Sub getWidth As Int
	Return mBase.Width
End Sub

Public Sub setTop(value As Int)
	mBase.Top = value
End Sub
Public Sub getTop As Int
	Return mBase.Top
End Sub

Public Sub setHeigth(value As Int)
	mBase.Height=value
	Btn1.Height = value
	Btn2.Height = value
	Numero.Height = value
	Btn1.TextSize=SetTextSize(Btn1)
	Btn2.TextSize=SetTextSize(Btn1)
	Numero.TextSize = SetTextSize(Numero)
End Sub
Public Sub getHeigth As Int
	Return mBase.Height
End Sub

Public Sub setValue(value As Int)
	Numero.Text=value
End Sub
Public Sub getValue As Int
	Return Numero.Text
End Sub

Public Sub setMaximum(value As Int)
	mMax=value
End Sub

Public Sub getMaximum As Int
	Return mMax
End Sub

Public Sub setMinimum(value As Int)
	mMin=value
End Sub

Public Sub getMinimum As Int
	Return mMin
End Sub

Private Sub SetTextSize(target As View) As Int
	Dim v As Canvas
	v.Initialize(target)
	Dim F As Float
	F = 0
	Do Until v.MeasureStringHeight("XgTj", Typeface.DEFAULT_BOLD, F) > target.Height
		F = F + 1
	Loop
	F = Floor(F/2.3)
	Return F
End Sub

Private Sub btn1_Click
	If Numero.Text > mMin Then
		Numero.Text=NumberFormat( Numero.Text-1,1,0)
		mValue = Numero.Text
		If SubExists(mTarget, mEventName & "_ValueChanged") Then
			CallSubDelayed2(mTarget, mEventName & "_ValueChanged",mValue)
		End If
	End If
End Sub

Private Sub btn2_Click
	If Numero.Text < mMax Then
		Numero.Text=NumberFormat( Numero.Text+1,1,0)
		mValue = Numero.Text
		If SubExists(mTarget, mEventName & "_ValueChanged") Then
			CallSubDelayed2(mTarget, mEventName & "_ValueChanged",mValue)
		End If
	End If
End Sub